//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 05: OpenMp
//
//  Description: Sort using openMP. Using the serial qsort
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc ompSort02.c -o ompSort02 -fopenmp
Executing:	./ompSort02

FOR N = 100000
Output in my Laptop:
0 0 16331 21720 32534 43513 48959 65535

real	0m0.033s
user	0m0.029s
sys	0m0.004s

FOR N = 10000000
Output in my Laptop:
0 0 16390 21846 32766 43699 49160 65535

real	0m2.845s
user	0m2.824s
sys	0m0.021s

*/
//************************************************************


// *******************************************************************
//#pragma GCC optimize("O3","unroll-loops","omit-frame-pointer","inline")
//#pragma GCC option("arch=native","tune=native","no-zero-upper")
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>


// Array Size
#define N          10000000

unsigned short int A[N] ;

// ***************************************
void createArray( void )
{
for (unsigned int i=0 ; i < N ; i++ )
	A[i] = rand() % 65536 ;
}


// ***************************************
int compar(const void *a, const void *b)
{
if ( *(unsigned short *)a >  *(unsigned short *)b )
	return 1 ;
if ( *(unsigned short *)a <  *(unsigned short *)b )
	return -1 ;
else
	return 0 ;
}

// ***************************************
void PrintResults()
{
for( unsigned int i = 0 ; i < N ; i++ )
	printf( "%hu ", A[i]) ;
putchar('\n') ;
}


// ***************************************
int main()
{

createArray() ;
qsort( A,  N, sizeof(unsigned short), compar ) ;

printf( "%hu %hu %hu %hu ",  A[0], A[1], A[N/4], A[N/3] ) ;
printf( "%hu %hu %hu %hu\n", A[N/2], A[2*N/3], A[3*N/4], A[N-1] ) ;
return 0 ;
}
